;' $Header$
	title	MEMSIZE -- Display Extended Memory Size
	page	58,122
	name	MEMSIZE

COMMENT|		Module Specifications

Copyright:  (C) Copyright 1987-2000 Qualitas, Inc.  All rights reserved.

Segmentation:  Group PGROUP:
	       Stack   segment STACK, byte-aligned, stack,  class 'prog'
	       Program segment CODE,  byte-aligned, public, class 'prog'
	       Data    segment DATA,  para-aligned, public, class 'prog'

Program derived from:  None.

Original code by:  Bob Smith, July, 1987.

Modifications by:  None.

|
.386
.xlist
	include MASM.INC
	include DOSCALL.INC
	include ASCII.INC
	include PTR.INC
	include XMS.INC
	include E820.INC
	include SMBIOS.INC
.list

PGROUP	group	STACK,CODE,DATA


; The following segment both positions class 'prog' segments lower in
; memory than others so the first byte of the resulting .COM file is
; in the CODE segment, as well as satisfies the LINKer's need to have
; a stack segment.

STACK	segment use16 byte stack 'prog' ; Start STACK segment
STACK	ends			; End STACK segment


; The following segment positions the CODE segment before the DATA segment
; so that we can define DATA segment values before they are used in
; the CODE segment to avoid forward references.

CODE	segment use16 byte public 'prog' ; Start CODE segment
CODE	ends			; End CODE segment


DATA	segment use16 para public 'prog' ; Start DATA segment
	assume	ds:PGROUP

@NIB0	equ	00Fh		; Nibble #0
@NIB1	equ	0F0h		; ...	  1

	public	OLDXMS_VEC
OLDXMS_VEC dd	?		; Save area for address of old XMS handler

	public	SMB_SEG,DMI_SEG
SMB_SEG dw	0		; SMBIOS segment (0=none)
DMI_SEG dw	0		; DMI ...

	public	MEMBUF
MEMBUF	MB_STR	<>		; Buffer for E820 results

	public	MEMCNT
MEMCNT	dw	0		; Count of memory entries

	public	MSG_COPY
MSG_COPY db	'MEMSIZE  -- Version 1.10 ',CR,LF
	db	'   (C) Copyright 1991-2000 Qualitas, Inc. '
	db	' All rights reserved.',CR,LF,EOS

	public	NUMBERS_HI
NUMBERS_HI db	'0123456789ABCDEF' ; Conversion table for BIND2BASE

	public	XMS_QRYXMB
XMS_QRYXMB db	@XMS_QRYXMB	; Function code to query XMS memory

	public	MSG_88xxSIZE
MSG_88xxSIZE   db '88xx Extended memory size is            '
MSG_88xxSIZE1  db '_ KB',CR,LF,EOS

	public	MSG_E801SIZEA
MSG_E801SIZEA  db 'E801 Configured memory size is          '
MSG_E801SIZEA1 db '_ KB',CR,LF,EOS

	public	MSG_E801SIZEB
MSG_E801SIZEB  db 'E801 Installed memory size is           '
MSG_E801SIZEB1 db '_ KB',CR,LF,EOS

	public	MSG_E881SIZEA
MSG_E881SIZEA  db 'E881 Configured memory size is          '
MSG_E881SIZEA1 db '_ KB',CR,LF,EOS

	public	MSG_E881SIZEB
MSG_E881SIZEB  db 'E881 Installed memory size is           '
MSG_E881SIZEB1 db '_ KB',CR,LF,EOS

	public	MSG_DA88SIZE
MSG_DA88SIZE   db 'DA88 Extended memory size is            '
MSG_DA88SIZE1  db '_ KB',CR,LF,EOS

	public	MSG_XMSSIZE
MSG_XMSSIZE    db 'XMS largest free size is                '
MSG_XMSSIZE1   db '_ KB',CR,LF
	       db 'XMS total free size is                  '
MSG_XMSSIZE2 db '_ KB'
	db CR,LF,EOS

	public	MSG_HMAPRES,MSG_HMAXPRES
MSG_HMAPRES db	'The HMA is present.',CR,LF,EOS
MSG_HMAXPRES db 'The HMA is NOT present.',CR,LF,EOS

	public	MSG_HMAFREE,MSG_HMAINUSE
MSG_HMAFREE  db 'The HMA is available.',CR,LF,EOS
MSG_HMAINUSE db 'The HMA is in use.',CR,LF,EOS

	public	MSG_E820SIZE,MSGBUF
MSG_E820SIZE db 'E820 Extended memory size is',CR,LF
	db	'    Base   Length',CR,LF
	db	'-----------------',CR,LF,EOS
;;;;;;; 	'12345678 12345678 = 12345678 KB'
MSGBUF	label	byte
MSGBUF1 db	'12345678 '
MSGBUF2 db	'12345678 = '
MSGBUF3 db	'12345678 KB, Type = '
	db	EOS


	public	MSG_E820_TAB
MSG_E820_TAB dw offset PGROUP:MSG_E820_TYP00
	dw	offset PGROUP:MSG_E820_TYP01
	dw	offset PGROUP:MSG_E820_TYP02
	dw	offset PGROUP:MSG_E820_TYP03
	dw	offset PGROUP:MSG_E820_TYP04
@MSG_E820_TABLEN equ ($-MSG_E820_TAB)/(type MSG_E820_TAB) ; # entries
	dw	offset PGROUP:MSG_E820_TYPUNK

	public	MSG_E820_TYP00,MSG_E820_TYP01,MSG_E820_TYP02
	public	MSG_E820_TYP03,MSG_E820_TYP04
MSG_E820_TYP00 db 'Unknown memory type      ',CR,LF,EOS
MSG_E820_TYP01 db 'Memory, available to OS  ',CR,LF,EOS
MSG_E820_TYP02 db 'Reserved (ROM, RAM, etc.)',CR,LF,EOS
MSG_E820_TYP03 db 'ACPI Reclaim Memory      ',CR,LF,EOS
MSG_E820_TYP04 db 'ACPI Non-volatile Memory ',CR,LF,EOS
MSG_E820_TYPUNK equ MSG_E820_TYP00

	public	MSG_DMI_PRES
MSG_DMI_PRES  db 'DMI header is present at segment '
MSG_DMI_PRES1 db '0000h, structures at '
MSG_DMI_PRES2 db '00000000h.',CR,LF,EOS

	public	MSG_SMB_PRES
MSG_SMB_PRES  db 'SMBIOS header is present at segment '
MSG_SMB_PRES1 db '0000h, structures at '
MSG_SMB_PRES2 db '00000000h.',CR,LF,EOS

	public	MSG_SMBDMI_XMEM
MSG_SMBDMI_XMEM db BEL,'*** SMBOIS/DMI strucs are in extended memory.',CR,LF,EOS

	public	MSG_SMB_MEM
MSG_SMB_MEM   db 'SMBIOS/DMI Memory from '
MSG_SMB_MEM1  db '________h KB to '
MSG_SMB_MEM2  db '________h KB.',CR,LF,EOS

	public	MSG_SMB_X20
MSG_SMB_X20 db	'No SMBIOS/DMI Memory Device Mapped Address records encountered.',CR,LF,EOS

	public	SMB20_CNT
SMB20_CNT dw	0		; Count of Type 20 memory records

DATA	ends			; End DATA segment


CODE	segment use16 byte public 'prog' ; Start CODE segment
	assume	cs:PGROUP,ds:nothing,es:nothing,fs:nothing,gs:nothing,ss:nothing
.xlist
	include PSP.INC 	; Define & skip over PSP area for .COM program
.list
	NPPROC	MEMSIZE -- Limit Extended Memory Size
	assume	ds:PGROUP,es:PGROUP,fs:nothing,gs:nothing,ss:nothing
COMMENT|

Display extended memory size using various APIs.

|

	DOSCALL @STROUT,MSG_COPY ; Display our copyright

; Display function 88 memory size

	call	Disp88		; Display the memory size

; Display function E801 memory size

	call	DispE801	; Display the memory size

; Display function E881 memory size

	call	DispE881	; Display the memory size

; Display function E820 memory size

	call	DispE820	; Display the memory size

; Display function DA88 memory size

	call	DispDA88	; Display the memory size

; Display DMI/SMBIOS memory size

	call	DispDMI_SMB	; Display the memory size

; Display XMS extended memory size

	call	DispXMS 	; Display the memory size

	ret			; Return to DOS

	assume	ds:nothing,es:nothing,fs:nothing,gs:nothing,ss:nothing

MEMSIZE endp			; End MEMSIZE procedure
	NPPROC	Disp88 -- Display Function 88 Size
	assume	ds:PGROUP,es:PGROUP,fs:nothing,gs:nothing,ss:nothing
COMMENT|

Display function 88 size

|

	REGSAVE <eax,cx,dx,di>	; Save registers

	xor	eax,eax 	; Zero to use as dword
	mov	ah,88h		; Get extmem size
	int	15h		; Request BIOS service

	lea	di,MSG_88xxSIZE1 ; ES:DI ==> units digit in message
	mov	cx,10		; Use base 10 to convert
	call	BIND2BASE	; Convert EAX to ASCII ending at ES:DI

	DOSCALL @STROUT,MSG_88xxSIZE ; Display the current size

	REGREST <di,dx,cx,eax>	; Restore

	ret			; Return to caller

	assume	ds:nothing,es:nothing,fs:nothing,gs:nothing,ss:nothing

Disp88	endp			; End Disp88 procedure
	NPPROC	DispE801 -- Display Function E801 Memory Size
	assume	ds:PGROUP,es:PGROUP,fs:nothing,gs:nothing,ss:nothing
COMMENT|

Display function E801 memory size

|

	pushad			; Save all EGP registers

	xor	cx,cx		; Set to known value
	xor	dx,dx		; ...
	mov	ax,0E801h	; Get function code to return extmem
	int	15h		; Request BIOS service
	jcxz	DispE801Exit	; Jump if not installed
				; Return AX = installed extmem in 1KB up to 16MB
				; ...	 BX = ...		 64KB above 16MB
				; ...	 CX = configured extmem in 1KB up to 16MB
				; ...	 DX = ...		 64KB above 16MB
	REGSAVE <ax,bx> 	; Save installed extmem

	movzx	eax,cx		; Get extmem up to 16MB in 1KB
	movzx	edx,dx		; Zero to use as dword
	shl	edx,16-10	; Convert from 64KB to 1KB
	add	eax,edx 	; Plus extmem up to 16MB

	lea	di,MSG_E801SIZEA1 ; ES:DI ==> units digit in message
	mov	cx,10		; Use base 10 to convert
	call	BIND2BASE	; Convert EAX to ASCII ending at ES:DI

	DOSCALL @STROUT,MSG_E801SIZEA ; Display the current size

	REGREST <bx,ax> 	; Restore installed extmem

	movzx	eax,ax		; Get extmem up to 16MB in 1KB, zero to use as dword
	movzx	edx,bx		; Get extmem above 16MB in 64KB, zero to use as dword
	shl	edx,16-10	; Convert from 64KB to 1KB
	add	eax,edx 	; Plus extmem up to 16MB

	lea	di,MSG_E801SIZEB1 ; ES:DI ==> units digit in message
	mov	cx,10		; Use base 10 to convert
	call	BIND2BASE	; Convert EAX to ASCII ending at ES:DI

	DOSCALL @STROUT,MSG_E801SIZEB ; Display the current size
DispE801Exit:
	popad			; Restore

	ret			; Return to caller

	assume	ds:nothing,es:nothing,fs:nothing,gs:nothing,ss:nothing

DispE801 endp			; End DispE801 procedure
	NPPROC	DispE881 -- Display Function E881 Memory Size
	assume	ds:PGROUP,es:PGROUP,fs:nothing,gs:nothing,ss:nothing
COMMENT|

Display function E881 memory size

|

	pushad			; Save all EGP registers

	xor	ecx,ecx 	; Set to known value
	xor	edx,edx 	; ...
	mov	ax,0E881h	; Get function code to return extmem
	int	15h		; Request BIOS service
	jecxz	DispE881Exit	; Jump if not supported
				; Return with EAX = ext mem between 1MB and 16MB in 1KB units
				;	      EBX = ext mem above 16MB in 64KB units
				;	      ECX = cfg mem between 1MB and 16MB in 1KB units
				;	      EDX = cfg mem above 16MB in 64KB units
	REGSAVE <eax,ebx>	; Save installed extmem

	mov	eax,ecx 	; Get extmem from 1MB to 16MB in 1KB
;;;;;;; mov	edx,edx 	; Get extmem above 16MB in 64KB units
	shl	edx,16-10	; Convert from 64KB to 1KB
	add	eax,edx 	; Plus extmem up to 16MB

	lea	di,MSG_E881SIZEA1 ; ES:DI ==> units digit in message
	mov	cx,10		; Use base 10 to convert
	call	BIND2BASE	; Convert EAX to ASCII ending at ES:DI

	DOSCALL @STROUT,MSG_E881SIZEA ; Display the current size

	REGREST <ebx,eax>	; Restore installed extmem

;;;;;;; mov	eax,eax 	; Get extmem from 1MB to 16MB in 1KB
;;;;;;; mov	ebx,ebx 	; Get extmem above 16MB in 64KB units
	shl	ebx,16-10	; Convert from 64KB to 1KB
	add	eax,ebx 	; Plus extmem up to 16MB

	lea	di,MSG_E881SIZEB1 ; ES:DI ==> units digit in message
	mov	cx,10		; Use base 10 to convert
	call	BIND2BASE	; Convert EAX to ASCII ending at ES:DI

	DOSCALL @STROUT,MSG_E881SIZEB ; Display the current size
DispE881Exit:
	popad			; Restore

	ret			; Return to caller

	assume	ds:nothing,es:nothing,fs:nothing,gs:nothing,ss:nothing

DispE881 endp			; End DispE881 procedure
	NPPROC	DispE820 -- Display E820 Memory Size
	assume	ds:PGROUP,es:PGROUP,fs:nothing,gs:nothing,ss:nothing
COMMENT|

Display E820 memory size

|

	pushad			; Save registers

	xor	ebx,ebx 	; Mark as start of map
DispE820Next:
	mov	eax,0E820h	; Some BIOSes require high-order word to be zero
	mov	ecx,type MB_STR ; Size of buffer
	mov	edx,'SMAP'      ; Special value
	lea	di,MEMBUF	; ES:DI ==> buffer
	int	15h		; Request BIOS service
	jc	near ptr DispE820Done ; Jump if no more data

; Note that we test for EBX == 0 at the end, because although that means
; there are no more entries, the contents of the buffer are still valid.

	cmp	MEMBUF.MB_TYPE,@MB_MEM ; Izit extmem?
	jne	near ptr DispE820Loop ; Jump if not

	cmp	MEMBUF.MB_BASE.EDQLO,1024*1024 ; Izit at or above 1MB?
	jb	near ptr DispE820Loop ; Jump if not

	cmp	MEMCNT,0	; Izit the first time?
	jne	short @F	; Jump if not

	DOSCALL @STROUT,MSG_E820SIZE ; Display the header
@@:
	inc	MEMCNT		; Mark as one more entry

	mov	eax,MEMBUF.MB_BASE.EDQLO ; Get base address
	lea	edi,MSGBUF1[7]	; ES:EDI ==> otuput save area
	mov	MSGBUF1.EDQLO,'    ' ; Clear the buffer
	mov	MSGBUF1.EDQHI,'    ' ; ...
	mov	cx,16		; Use base 16 to convert
	call	BIND2BASE	; Convert EAX to ASCII ending at ES:DI

	mov	eax,MEMBUF.MB_LEN.EDQLO ; Get length
	lea	edi,MSGBUF2[7]	; ES:EDI ==> otuput save area
	mov	MSGBUF2.EDQLO,'    ' ; Clear the buffer
	mov	MSGBUF2.EDQHI,'    ' ; ...
;;;;;;; mov	cx,16		; Use base 16 to convert
	call	BIND2BASE	; Convert EAX to ASCII ending at ES:DI

;;;;;;; mov	eax,MEMBUF.MB_LEN.EDQLO ; Get length
	shr	eax,10-0	; Convert from bytes to KB
	lea	edi,MSGBUF3[7]	; ES:EDI ==> otuput save area
	mov	MSGBUF3.EDQLO,'    ' ; Clear the buffer
	mov	MSGBUF3.EDQHI,'    ' ; ...
	mov	cx,10		; Use base 10 to convert
	call	BIND2BASE	; Convert EAX to ASCII ending at ES:DI

	DOSCALL @STROUT,MSGBUF	; Display the message

; Display the type

	mov	eax,MEMBUF.MB_TYPE ; Get memory type

	cmp	eax,@MSG_E820_TABLEN ; Izit too large?
	jb	short @F	; Jump if not

	mov	eax,@MSG_E820_TABLEN ; Use maximum entry
@@:
	mov	dx,MSG_E820_TAB[eax*(type MSG_E820_TAB)] ; DS:DX ==> type
	DOSCALL @STROUT 	; Display the type
DispE820Loop:
	cmp	ebx,0		; Izit over?
	jne	near ptr DispE820Next ; Jump if notmore data
DispE820Done:
	popad			; Restore

	ret			; Return to caller

	assume	ds:nothing,es:nothing,fs:nothing,gs:nothing,ss:nothing

DispE820 endp			; End DispE820 procedure
	NPPROC	DispDA88 -- Display Function DA88 Memory Size
	assume	ds:nothing,es:nothing,fs:nothing,gs:nothing,ss:nothing
COMMENT|

Diusplay function DA88 memory size

|

	pushad			; Save all EGP registers

	mov	ax,0DA88h	; Get PCI extmem size
	int	15h		; Request BIOS service
				; Return CL:BX = ext mem in KB, AX=0
	cmp	ax,0		; Did it work?
	jne	short @F	; Jump if not

	movzx	ax,cl		; Copy high-order byte
	shl	eax,16		; Shift to high-order word
	mov	ax,bx		; Copy low-order word

	lea	di,MSG_DA88SIZE1 ; ES:DI ==> units digit in message
	mov	cx,10		; Use base 10 to convert
	call	BIND2BASE	; Convert EAX to ASCII ending at ES:DI

	DOSCALL @STROUT,MSG_DA88SIZE ; Display the current size
@@:
	popad			; Restore

	ret			; Return to caller

	assume	ds:nothing,es:nothing,fs:nothing,gs:nothing,ss:nothing

DispDA88 endp			; End DispDA88 procedure
	NPPROC	DispXMS -- Display XMS Memory Size
	assume	ds:PGROUP,es:PGROUP,fs:nothing,gs:nothing,ss:nothing
COMMENT|

Display XMS memory size

|

	pushad			; Save all EGP registers

	mov	ax,4300h	; Function code to check on presence
	int	2Fh		; Request redirector service

	cmp	al,80h		; Izit installed?
	jne	near ptr DispXMS_EXIT ; Jump if not present

	push	es		; Save for a moment

	mov	ax,4310h	; Function code to obtain address of handler
	int	2Fh		; Request redirector service
	assume	es:nothing	; Tell the assembler about it

	mov	OLDXMS_VEC.VOFF,bx ; Save for later use
	mov	OLDXMS_VEC.VSEG,es ; ...

	pop	es		; Restore
	assume	es:PGROUP	; Tell the assembler about it

; If there's an XMS 3.0 handler present, use the extended services

	mov	ah,@XMS_VERS	; Function code to get XMS version #
	call	OLDXMS_VEC	; Request XMS service
				; AX = XMS version
				; BX = MAX version
	cmp	ax,0300h	; Izit version 3.0 or above?
	jb	short @F	; Jump if so

	mov	XMS_QRYXMB,@XMS_QRY2XMB ; Use extended services
@@:
	xor	eax,eax 	; Zero to use as dword
	xor	edx,edx 	; ...
	mov	ah,XMS_QRYXMB	; Function code to query free extmem
	call	OLDXMS_VEC	; Request XMS service
				; Return with eAX = size of largest free
				;	      eDX = total amount
				;	      eCX = highest ending address of
				;		    any memory block (if XMS 3.0)
	cmp	eax,0		; Check for error
	jne	short @F	; Jump if there's something

	cmp	bl,0A0h 	; Check for insufficient extmem
	je	short @F	; Jump if so

	cmp	bl,0		; Check for other error
	jne	near ptr DispXMS_EXIT ; Jump if so
@@:
	lea	di,MSG_XMSSIZE1 ; ES:DI ==> units digit in message
	mov	cx,10		; Use base 10 to convert
	call	BIND2BASE	; Convert EAX to ASCII ending at ES:DI

	mov	eax,edx 	; Copy size of total
	lea	di,MSG_XMSSIZE2 ; ES:DI ==> units digit in message
	mov	cx,10		; Use base 10 to convert
	call	BIND2BASE	; Convert EAX to ASCII ending at ES:DI

	DOSCALL @STROUT,MSG_XMSSIZE ; Display the current size

; Check on the state of the HMA

	mov	ah,@XMS_VERS	; Function code to get version # and HMA state
	call	OLDXMS_VEC	; Request XMS service

	cmp	dx,1		; Check on HMA state
	je	short DispXMS_HMAPRES ; Jump if it's present

	DOSCALL @STROUT,MSG_HMAXPRES ; Tell 'em it doesn't exist

	jmp	short DispXMS_EXIT ; Join common exit code

DispXMS_HMAPRES:
	DOSCALL @STROUT,MSG_HMAPRES ; Tell 'em it exists

	mov	ah,@XMS_REQHMA	; Function code to request HMA
	call	OLDXMS_VEC	; Request XMS service

	cmp	ax,1		; Did we get it?
	jne	short DispXMS_HMAINUSE ; Jump if not

	DOSCALL @STROUT,MSG_HMAFREE ; Tell 'em the HMA is free

	mov	ah,@XMS_RELHMA	; Function code to release HMA
	call	OLDXMS_VEC	; Request XMS service

	jmp	short DispXMS_EXIT ; Join common exit code

DispXMS_HMAINUSE:
	DOSCALL @STROUT,MSG_HMAINUSE ; Tell 'em the HMA is in use
DispXMS_EXIT:
	popad			; Restore

	ret			; Return to caller

	assume	ds:nothing,es:nothing,fs:nothing,gs:nothing,ss:nothing

DispXMS endp			; End DispXMS procedure
	NPPROC	DispDMI_SMB -- Display DMI/SMBIOS Memory Size
	assume	ds:PGROUP,es:PGROUP,fs:nothing,gs:nothing,ss:nothing
COMMENT|

Display DMI/SMBIOS memory size

|

; Check to see if there is DMI or SMBIOS present

	call	CheckDMI_SMB ; Check on presence

; Display memory size if SMBIOS is present.
; Note that SMBIOS includes DMI so we don't need
; to check for DMI after displaying SMBIOS.

	cmp	SMB_SEG,0	; Izit absent?
	je	short @F	; Jump if so

	call	DispSMB 	; Display the SMBIOS memory size
	
	jmp	short DispDMI_SMBExit ; Join common exit code
	
@@:

; Display memory size if DMI is present.

	cmp	DMI_SEG,0	; Izit absent?
	je	short @F	; Jump if so

	call	DispDMI 	; Display the DMI memory size
@@:

DispDMI_SMBExit:
	ret			; Return to caller

	assume	ds:nothing,es:nothing,fs:nothing,gs:nothing,ss:nothing

DispDMI_SMB endp		; End DispDMI_SMB procedure
	NPPROC	CheckDMI_SMB -- Check On Presence of DMI and SMBIOS
	assume	ds:PGROUP,es:PGROUP,fs:nothing,gs:nothing,ss:nothing
COMMENT|

Check on presence of DMI and SMBIOS

|

	REGSAVE <ax,es> 	; Save registers

	mov	ax,0F000h	; Initialize starting segment
CheckDMI_SMBNext:
	mov	es,ax		; Address the next segment
	assume	es:nothing	; Tell the assembler about it

	cmp	es:[0].EDD,@SMBIOS_SIG ; Duzit match?
	je	short CheckDMI_SMB1 ; Jump if not

	cmp	es:[0].EDD,@DMI_SIG1 ; Duzit match?
	jne	short CheckDMI_SMBLoop ; Jump if not

	cmp	es:[4].LO,@DMI_SIG2 ; Duzit match?
	jne	short CheckDMI_SMBLoop ; Jump if so

	mov	DMI_SEG,es	; Save the segment #

	jmp	short CheckDMI_SMBLoop ; Go around again

CheckDMI_SMB1:
	mov	SMB_SEG,es	; Save the segment #

	jmp	short CheckDMI_SMBLoop ; Go around again

CheckDMI_SMBLoop:
	inc	ax		; Skip to next starting segment
	jnz	short CheckDMI_SMBNext ; Jump if more to check

	REGREST <es,ax> 	; Restore
	assume	es:nothing	; Tell the assembler about it

	ret			; Return to caller

	assume	ds:nothing,es:nothing,fs:nothing,gs:nothing,ss:nothing

CheckDMI_SMB endp		; End CheckDMI_SMB procedure
	NPPROC	DispDMI -- Display DMI Memory Size
	assume	ds:PGROUP,es:PGROUP,fs:nothing,gs:nothing,ss:nothing
COMMENT|

Display DMI memory size.

|

	pushad			; Save all EGP registers
	push	fs		; Save register

	mov	fs,DMI_SEG	; Get DMI segment
	assume	fs:nothing	; Tell the assembler about it

	movzx	eax,DMI_SEG	; Get the segment # (zero to use as dword)
	lea	di,MSG_DMI_PRES1[3] ; ES:DI ==> output save area
	mov	cx,16		; Use base 16 to convert
	call	BIND2BASE	; Convert EAX to ASCII ending at ES:DI

	mov	eax,fs:[0].DMI_ADDR ; Get the physical address
	lea	di,MSG_DMI_PRES2[7] ; ES:DI ==> output save area
;;;;;;; mov	cx,16		; Use base 16 to convert
	call	BIND2BASE	; Convert EAX to ASCII ending at ES:DI
	DOSCALL @STROUT,MSG_DMI_PRES ; Display the message

	push	fs:[0].DMI_CNT	; Pass # structures
	push	fs:[0].DMI_ADDR ; ...  physical address
	call	DispSMBMem	; Display SMBIOS/DMI memory

	pop	fs		; Restore
	assume	fs:nothing	; Tell the assembler about it
	popad			; Restore

	ret			; Return to caller

	assume	ds:nothing,es:nothing,fs:nothing,gs:nothing,ss:nothing

DispDMI endp			; End DispDMI procedure
	NPPROC	DispSMB -- Display SMBIOS Memory Size
	assume	ds:PGROUP,es:PGROUP,fs:nothing,gs:nothing,ss:nothing
COMMENT|

Display SMBIOS memory size.

|

	pushad			; Save all EGP registers
	push	fs		; Save register

	mov	fs,SMB_SEG	; Get the SMBOS segment #
	assume	fs:nothing	; Tell the assembler about it

	movzx	eax,SMB_SEG	; Get the segment # (zero to use as dword)
	lea	di,MSG_SMB_PRES1[3] ; ES:DI ==> output save area
	mov	cx,16		; Use base 16 to convert
	call	BIND2BASE	; Convert EAX to ASCII ending at ES:DI
	
	mov	eax,fs:[0].SMBIOS_DMI.DMI_ADDR ; Get the physical address
	lea	di,MSG_SMB_PRES2[7] ; ES:DI ==> output save area
;;;;;;; mov	cx,16		; Use base 16 to convert
	call	BIND2BASE	; Convert EAX to ASCII ending at ES:DI
	DOSCALL @STROUT,MSG_SMB_PRES ; Display the message

	push	fs:[0].SMBIOS_DMI.DMI_CNT  ; Pass # structures
	push	fs:[0].SMBIOS_DMI.DMI_ADDR ; ...  physical address
	call	DispSMBMem	; Display SMBIOS/DMI memory

	pop	fs		; Restore
	assume	fs:nothing	; Tell the assembler about it
	popad			; Restore

	ret			; Return to caller

	assume	ds:nothing,es:nothing,fs:nothing,gs:nothing,ss:nothing

DispSMB endp			; End DispSMB procedure
	NPPROC	DispSMBMem -- Display SMBIOS/DMI Memory
	assume	ds:PGROUP,es:PGROUP,fs:nothing,gs:nothing,ss:nothing
COMMENT|

Display SMBIOS/DMI memory.

Search for Memory Device Mapped Address (Type 20) record.
Note that the values reported by some BIOSes are not reliable.

|

DispSMBMem_STR struc

	dw	?		; Caller's BP
	dw	?		; ...	   IP
DispSMBMemAddr dd ?		; Physical address of SMBIOS/DMI structures
DispSMBMemCnt  dw ?		; # structures

DispSMBMem_STR ends

	push	bp		; Prepare to address the stack
	mov	bp,sp		; Hello, Mr. Stack

	pushad			; Save all EGP registers
	push	fs		; Save register

	mov	eax,[bp].DispSMBMemAddr ; Get physical address
	mov	cx,[bp].DispSMBMemCnt ; Get # structures

	cmp	eax,0FFF00h	; Izit too large?
	ja	near ptr DispSMBMemXmem ; Jump if so

	mov	edi,eax 	; Copy as offset
	and	edi,@NIB0	; Isolate the low-order nibble

	ror	eax,4-0 	; Convert from bytes to paras
	mov	fs,ax		; Address the struc segment
	assume	fs:nothing	; Tell the assembler about it
DispSMBMemNext:
	cmp	fs:[di].SMBHDR_TYPE,@SMB_MEMDEVMAP ; Izit Memory Device
				; Mapped Address?
	je	short DispSMBMem1 ; Jump if so

; Skip over the structure

DispSMBMemSkip:

; Handle Memory Controller Information specially as some BIOSes
; (Award Modular BIOS v4.51PG, P6BX-A+ Ver 3.2c, 11/28/1998)
; don't put two zero bytes after it

	cmp	fs:[di].SMBHDR_TYPE,@SMB_MEMCTRL ; Izit Memory Controller Information?
	jne	short DispSMBMemSkip1 ; Jump if not

	movzx	ax,fs:[di].SMBHDR_LEN ; Get the length, zero to use as word
	add	di,ax		; Skip over the structure

	cmp	fs:[di].ELO,0000h ; Izit present?
	je	short DispSMBMemSkip2 ; Jump if so
	
	jmp	DispSMBMemLoop	; Go around again

	
DispSMBMemSkip1:
	movzx	ax,fs:[di].SMBHDR_LEN ; Get the length, zero to use as word
	add	di,ax		; Skip over the structure
DispSMBMemSkip2:
	REGSAVE <cx,es> 	; Save for a moment
	
	mov	ax,fs		; Get the SMBIOS segment #
	mov	es,ax		; Copy for string ops
	assume	es:nothing	; Tell the assembler about it

; Skip over the strings

	mov	al,0		; Search for this
	mov	cx,-1		; We know it's there
@@:
  repne scas	es:[di].LO	; Skip over next string
;;;;;;; jne	short ???	; Jump if not found???

; Check for last string

	scas	es:[di].LO	; Izit the last string?
	jne	short @B	; Jump if not

	REGREST <es,cx> 	; Restore
	assume	es:PGROUP	; Tell the assembler about it
DispSMBMemLoop:
	loop	DispSMBMemNext	; Go around again

; See if we encountered any Type 20 records

	cmp	SMB20_CNT,0	; Any records encountered?
	jne	short @F	; Jump if so

	DOSCALL @STROUT,MSG_SMB_X20 ; Tell 'em the bad news
@@:
	jmp	short DispSMBMemExit ; Join common exit code
	

; A Memory Device Mapped Address structure has been found

DispSMBMem1:

; Format the starting address

	REGSAVE <cx,di> 	; Save for a moment

	mov	eax,fs:[di].SMB20_START ; Get the starting
				; physical address in KB
	lea	di,MSG_SMB_MEM1[7]  ; ES:DI ==> output save area
	mov	MSG_SMB_MEM1[0].EDQLO,'0000' ; Zero the buffer
	mov	MSG_SMB_MEM1[0].EDQHI,'0000' ; ...
	mov	cx,16		; Use base 16 to convert
	call	BIND2BASE	; Convert EAX to ASCII ending at ES:DI

	REGREST <di,cx> 	; Restore

; Format the ending address

	REGSAVE <cx,di> 	; Save for a moment

	mov	eax,fs:[di].SMB20_END ; Get the ending
				; physical address in KB
	lea	di,MSG_SMB_MEM2[7] ; ES:DI ==> output save area
	mov	MSG_SMB_MEM2[0].EDQLO,'0000' ; Zero the buffer
	mov	MSG_SMB_MEM2[0].EDQHI,'0000' ; ...
	mov	cx,16		; Use base 16 to convert
	call	BIND2BASE	; Convert EAX to ASCII ending at ES:DI

	REGREST <di,cx> 	; Restore

	DOSCALL @STROUT,MSG_SMB_MEM ; Display the range

	inc	SMB20_CNT	; Count in another Type 20 record

	jmp	DispSMBMemSkip ; Go around again


DispSMBMemXmem:
	DOSCALL @STROUT,MSG_SMBDMI_XMEM ; Tell 'em the bad news
DispSMBMemExit:
	pop	fs		; Restore
	assume	fs:nothing	; Tell the assembler about it
	popad			; Restore

	pop	bp		; Restore

	ret	4+2		; Return to caller, popping arguments

	assume	ds:nothing,es:nothing,fs:nothing,gs:nothing,ss:nothing

DispSMBMem endp 		; End DispSMBMem procedure
	NPPROC	BIND2BASE -- Convert From Binary to Specified Base
	assume	ds:nothing,es:nothing,fs:nothing,gs:nothing,ss:nothing
COMMENT|

BIND2BASE -- Convert the number in EAX to ASCII in base CX storing the
low-order digit of the # at ES:DI.

On exit:

ES:DI	==>	next byte below last one stored

|

	REGSAVE <eax,ecx,edx,si,bp> ; Save registers

	pushf			; Save all flags
	std			; Direction backwards for MOVSB

	mov	bp,7		; Go through this many times
	movzx	ecx,cx		; Zero to use as dword
BIND2BASE_LOOP:
	xor	edx,edx 	; Zero high-order dword for division
	div	ecx		; Divide by number base
				; EDX has remainder, EAX has quotient
	lea	si,NUMBERS_HI	; Get address of table
	add	si,dx		; Offset into table

	movs	es:[di].LO,NUMBERS_HI[si] ; Store in result

	and	eax,eax 	; Check for zero quotient
	jz	short BIND2BASE_EXIT ; That's all folks

	dec	bp		; Check for last digit
	jnz	short BIND2BASE_LOOP ; Not done yet
BIND2BASE_EXIT:
	popf			; Restore flags

	REGREST <bp,si,edx,ecx,eax> ; Restore

	ret			; Return to caller

	assume	ds:nothing,es:nothing,fs:nothing,gs:nothing,ss:nothing

BIND2BASE endp			; End BIND2BASE procedure

CODE	ends			; End CODE segment

	MEND	MEMSIZE 	; End MEMSIZE module
